#include <Windows.h>
#include <tchar.h>

const TCHAR* gszClsName		= _T("Win32App");
const TCHAR* szWndCaption	= _T("Demo RegisterClassEx & UnregisterClass");
static HINSTANCE  ghInstance;
//////////////////////////////////////////////////////////////////////////
LRESULT CALLBACK WndProc(HWND hWnd, UINT nMsg, WPARAM wParam, LPARAM lParam)
{	
	static const UINT ID_BTNREAD	= 1003;
	static const UINT ID_LABINFO	= 1002;
	static HWND hButton;
	switch (nMsg)
	{
		case WM_CREATE:
		{
			//--: Move Main wnd to center of screen
			RECT rtMainWnd;
			GetClientRect(hWnd, &rtMainWnd);
			UINT nSrnWidth		= GetSystemMetrics(SM_CXFULLSCREEN);
			UINT nSrnHeight		= GetSystemMetrics(SM_CYFULLSCREEN);
			UINT nWndWidth		= (rtMainWnd.right - rtMainWnd.left);
			UINT nWndHeight		= (rtMainWnd.bottom - rtMainWnd.top);
			UINT nLeft			= (nSrnWidth - nWndWidth) / 2;
			UINT nTop			= (nSrnHeight - nWndHeight) / 2;
			MoveWindow(hWnd, nLeft, nTop, nWndWidth, nWndHeight, TRUE);

			CreateWindow(_T("Button"), _T("Get Class Info"), WS_VISIBLE|WS_CHILD, 200, 0, 150, 50, hWnd, (HMENU)ID_BTNREAD, 0, 0);
			CreateWindow(_T("STATIC"), _T(""), WS_VISIBLE|WS_CHILD, 0, 60, 800, 400, hWnd, (HMENU)ID_LABINFO, 0, 0);

			break;
		}
		case WM_COMMAND:
		{
			switch (wParam)
			{
				case ID_BTNREAD:
				{
					WNDCLASSEX wcx	= {0};
					wcx.cbSize		= sizeof(wcx);
					TCHAR szClassName[256]	= {0};
					GetClassName(hWnd, szClassName, 256);
					if (GetClassInfoEx(GetModuleHandle(NULL), szClassName, &wcx))
					{
						TCHAR szClassInfo[1024];
						_stprintf(szClassInfo, 
							      _T("ClassName:		%s\n")
								  _T("Style:			%d\n")
								  _T("class Extra:		%s\n")
								  _T("Wnd Extra:		%d\n")    
								  _T("Cursor:			0X%X\n")
								  _T("Icon:			0X%X\n")
								  _T("Background:		0X%0X\n")
								  _T("MenuName:		%s\n")
								  _T("Instance:		0X%X\n")
								  _T("WndProc:		X%06X\n"),
								  wcx.lpszClassName,
								  wcx.style,
								  wcx.cbClsExtra,
								  wcx.cbWndExtra,
								  wcx.hCursor,
								  wcx.hIcon,
								  wcx.hbrBackground,
								  wcx.lpszMenuName,
								  wcx.hInstance,
								  wcx.lpfnWndProc);
						SetWindowText(GetDlgItem(hWnd, ID_LABINFO), szClassInfo);
						OutputDebugString(szClassInfo);
					}
		
					break;
				}
			}
			break;
		}
		case WM_DESTROY:
		{
			PostQuitMessage(0);

			break;
		}
	}

	return ::DefWindowProc(hWnd, nMsg, wParam, lParam);
}

//////////////////////////////////////////////////////////////////////////
bool RegisterWndClass(HINSTANCE hInstance, const TCHAR* szClsName)
{
	WNDCLASSEX wcs		= {0};
	wcs.cbSize			= sizeof(WNDCLASSEX);
	wcs.hbrBackground	= (HBRUSH)GetStockObject(COLOR_APPWORKSPACE);
	wcs.lpszClassName	= szClsName;
	wcs.lpfnWndProc		= WndProc;
	wcs.hCursor			= LoadCursor(NULL, MAKEINTRESOURCE(IDC_ARROW));
	wcs.hIcon			= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_APPLICATION));
	wcs.style			= CS_VREDRAW|CS_HREDRAW;
	
	return (0 != RegisterClassEx(&wcs));
}

//////////////////////////////////////////////////////////////////////////
bool CreateMainWnd(HINSTANCE hInstance, const TCHAR* szClsName, const TCHAR* szWndCaption)
{
	if (NULL != szClsName && NULL != szWndCaption)
	{
		HWND hWnd = CreateWindowEx(WS_EX_APPWINDOW, szClsName, szWndCaption, WS_VISIBLE|WS_POPUPWINDOW|WS_CAPTION, 
								0, 0, 800, 480, NULL, NULL, hInstance, hInstance);
		if (NULL != hWnd && IsWindow(hWnd))
		{
			ShowWindow(hWnd, SW_SHOW);
			UpdateWindow(hWnd);
			return true;
		}
	}
	return false;
}

//////////////////////////////////////////////////////////////////////////
void RunMessageLoop()
{
	MSG Msg;
	while (true)
	{
		while (PeekMessage(&Msg, NULL, 0, 0, PM_REMOVE))
		{
			if (WM_QUIT == Msg.message)
			{
				if (UnregisterClass(gszClsName, ghInstance))
				{
					TCHAR szInfo[256];
					_stprintf(szInfo, _T("Destroy [%s] window class"), gszClsName);
					OutputDebugString(szInfo);
				}
				return;
			}

			TranslateMessage(&Msg);
			DispatchMessage(&Msg);
		}
	}
}
//////////////////////////////////////////////////////////////////////////
BOOL WINAPI _tWinMain(HINSTANCE hInstance, HINSTANCE hPreInstance, LPTSTR szCmdLine, int nShowCmd)
{
	ghInstance = hInstance;
	if (RegisterWndClass(hInstance, gszClsName))
	{
		if (CreateMainWnd(hInstance, gszClsName, szWndCaption))
		{
			RunMessageLoop();
		}
	}

	return TRUE;
}